#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>

//**************************************
//	f[^`
//**************************************

//`N̒萔
//rbOGfBAŏǂŖȂ
//SMFĊ{IɃrbOGfBAȂ̂(LEցEM)
const int MThd = 0x4d546864;
const int MTrk = 0x4d54726b;


//--------------------------------------
//	SMFnf[^\̒`
//--------------------------------------
//midiCxg1
enum midieventtype{NOFF,NON,PKP,CC,PC,AT,PB,X};	//oCiɕׂ
struct midievent{
	enum midieventtype type;
	int metaeventtype;	//^Cxg̎ typeXɂȂ sysex,̑-1
	int time;	//f^ȂċȊJñ^C
	int len;	//data̒
	unsigned char *data;	//ϒ̃f[^
};
typedef struct midievent midievent;

midievent *newmidievent(){
	midievent *ret;
	ret = malloc(sizeof(midievent));
	if(ret == NULL){fprintf(stderr,"mallocł('A`) newmidievent\n");exit(1);}
	return ret;
}

//midi`l1ێPXg
struct midichlist{
	midievent *event;
	struct midichlist *next;	//PXg
};
typedef struct midichlist midichlist;

midichlist *newmidichlist(){
	midichlist *ret;
	ret = malloc(sizeof(midichlist));
	if(ret == NULL){fprintf(stderr,"mallocł('A`) newmidichlist\n");exit(1);}
	ret->event = newmidievent();
	ret->next = NULL;
	return ret;
}

//smf1
//̎łchmaster1Ԗڂ̗vf͋ɂȂ
//format0ł̓gbNch
struct midiseq{
	int trackcount;	//gbN(}X^[gbN)
	int seqlength;	//Ȃ̒ łgbN̒lg
	int timebase;	//SMF̕\(_΍)
	midichlist **track;	//egbN
	midichlist **trackcursor;	//̎gp̗vf f[^ǉƂ͍Ō̗vf
	midichlist *master;	//}X^[gbN
	midichlist *mastercursor;	//̎gp̗vf f[^ǉƂ͍Ō̗vf
};
typedef struct midiseq midiseq;

midiseq *newmidiseq(const int trackcount){
	midiseq *ret;
	ret = malloc(sizeof(midiseq));
	if(ret == NULL){fprintf(stderr,"mallocł('A`) newmidiseq\n");exit(1);}

	ret->trackcount = trackcount;
	ret->seqlength = 0;
	ret->track = malloc(sizeof(midichlist **) * trackcount);
	if(ret->track == NULL){fprintf(stderr,"mallocł('A`) newmidiseq\n");exit(1);}
	ret->trackcursor = malloc(sizeof(midichlist **) * trackcount);
	if(ret->trackcursor == NULL){fprintf(stderr,"mallocł('A`) newmidiseq\n");exit(1);}
	//egbN̏
	int i;
	for(i=0;i<trackcount;i++){
		ret->trackcursor[i] = ret->track[i] = newmidichlist();
	}
	ret->mastercursor = ret->master = newmidichlist();

	return ret;
}


//**************************************
//	SMFǂނ
//**************************************

//oCgI[_[𔽓]Ă_֐
//unsignedƂď͗l
//rbOGfBAł͒Pɋ֐ɂ΂
//input̂ό`Ė߂lɂȂ
//http://torasukenote.blog120.fc2.com/blog-entry-106.html
int convertEndian(void *input, size_t s){
    // GfBAϊȂ֐
    // stdlib.hCN[hĂB
    // yz: void *input...GfBAϊΏۂւ̃|C^
    // yz: size_t    s...ϊΏۂ̃oCg

    int i;   // JE^
    char *temp;   // ϊɗpꎞIz

    if((temp = (char *)calloc( s, sizeof(char))) == NULL){
    	abort();
        return 1;   // ̈mۂłisj
    }

    for(i=0; i<s; i++){   // inputf[^tempɈꎞۊ
        temp[i] = ((char *)input)[i];
    }

    for(i=1; i<=s; i++){   // tempf[^tɂinput֑
        ((char *)input)[i-1] = temp[s-i];
    }

    free(temp);   // mۂ̈

    return 0;   // I
}



//f^^CǂݏoĕԂ
//łɓǂݏooCgĕԂ
int deltatime(FILE *fp, int *datacursor){
	unsigned char rchar;	//ǂݍݗp
	int i = 0;	//oCgJEgp
	int dt = 0;	//߂lvZp

	//1oCgǂ f^^ĈrbOGfBAŕł('A`)
	do{
		dt <<= 7;	//2oCgڂʂ𔭊
		fread(&rchar,1,1,fp);
		//printf("%02x",rchar);
		dt |= (int)(rchar & 0x7f);	//f^^CorőĂ
		i++;
	}while(rchar & 0x80);
	if(i >= 4){fprintf(stderr,"f^^Cłv?%d\n",dt);}

	*datacursor += i;
	//printf("\t%d\n",dt);
	return dt;
}

//1MTrkǂݍ tH[}bg0tracknum𕉐ɂ
//retrackɃf[^˂ŕԂ
void readtrack(FILE *fp, midiseq *retrack, const int tracknum){
	unsigned int rint;	//ǂݍݗp
	unsigned char rchar;	//ǂݍݗp

	int chunksize;	//f[^ɓĂ
	int datacursor = 0;	//oCg𐔂

	int eventtime = 0;	//midi^CŐ
	enum midieventtype eventtype;	//{NON,NOFF,PKP,CC,PC,AT,PB,X};
	int eventch;	//̃Cxg̃`l
	int eventlen;	//̃Cxg̃f[^̒
	unsigned char *eventdata;	//̃Cxg̃f[^ oCi

	int ismetaevent;	//^Cxgǂ
	midichlist *localcursor;	//}X^[gbNȊOłvOg񂷗p

	//`NJ ŏȂ̂MtrkȂƂ
	fread(&rint,4,1,fp);	//MThd
	convertEndian(&rint,4);
	if(rint != MTrk){fprintf(stderr,"MTrkŎn܂ĂȂ('A`)%x gbN%d\n",rint,tracknum);exit(1);}

	fread(&rint,4,1,fp);	//f[^
	convertEndian(&rint,4);
	chunksize = rint;
	//printf("%d\n",chunksize);

	//Format1̏ꍇ͑S`ltracknumɓ̂ŏ
	eventch = tracknum;

	//f[^ǂ߁_(^o^)^
	//datacursor̐XVKv
	while(datacursor < chunksize){
		//܂f^^C
		eventtime += deltatime(fp,&datacursor);
		if(eventtime > retrack->seqlength){retrack->seqlength = eventtime;}

		//midiCxg1cƎvAjOXe[^XYꂸ
		fread(&rchar,1,1,fp);	datacursor += 1;	//midiCxg(4bit)ƃ`l(4bit)
		if(rchar & 0x80){
			//SȃCxg
			//Cxg̎ނƃ`lǂݏo
			if(rchar == 0xff){ismetaevent = -1;}else{ismetaevent = 0;}	//^CxgǂŔ
			eventtype = (int)((rchar & 0x70) >> 4);
			if(tracknum < 0){eventch = (int)(rchar & 0x0f);}	//Format0̏ꍇ`l𔽉f
		}else{		//jOXe[^X
			fseek(fp,-1,SEEK_CUR);	datacursor += -1;	//ǂ1oCg߂
		}
		//Cxg̃f[^ǂ


		//^Cxgʂɏ
		if(ismetaevent){

			if(tracknum <= 0){	//tH[}bg0܂̓tH[}bg1̃}X^[gbN
				localcursor = retrack->mastercursor = retrack->mastercursor->next = newmidichlist();	//Cxgp\̊m
			}else{	//tH[}bg1̊egbN
				localcursor = retrack->trackcursor[eventch] = retrack->trackcursor[eventch]->next = newmidichlist();	//Cxgp\̊m
			}

			//f[^ǂݍŕۑ
			localcursor->event->type = eventtype;
			fread(&rchar,1,1,fp);	datacursor += 1;
			localcursor->event->metaeventtype = (int)rchar;
			localcursor->event->time = eventtime;
			localcursor->event->len = eventlen = deltatime(fp,&datacursor);	//CxgϒȂ̂deltatimeĂ

			//^f[^K؂ȃoCgǂ
			if(eventlen > 0){
				eventdata = malloc(eventlen);
				if(eventdata == NULL){fprintf(stderr,"mallocł('A`) readtrack\n");exit(1);}
				fread(eventdata,1,eventlen,fp);		datacursor += eventlen;
			}else{
				eventdata = NULL;
			}
			localcursor->event->data = eventdata;

		}else{	//^CxgȊÕCxg
			//򂷂Oɗ̈mۂȂ
			retrack->trackcursor[eventch] = retrack->trackcursor[eventch]->next = newmidichlist();	//Cxgp\̊m
			retrack->trackcursor[eventch]->event->type = eventtype;
			retrack->trackcursor[eventch]->event->metaeventtype = -1;	//^CxgȂ
			retrack->trackcursor[eventch]->event->time = eventtime;

			//Cxg̒m
			switch(eventtype){	//{NON,NOFF,PKP,CC,PC,AT,PB,X};
				case PC:	//f[^1oCĝ
				case AT:
					eventlen = retrack->trackcursor[eventch]->event->len = 1;
					break;
				case NON:	//f[^2oCĝ
				case NOFF:
				case PKP:
				case PB:
				case CC:
					eventlen = retrack->trackcursor[eventch]->event->len = 2;
					break;
				case X:	//CxgϒȂ̂deltatimeĂ
					eventlen = retrack->trackcursor[eventch]->event->len = deltatime(fp,&datacursor);
					break;
				default:	//
				fprintf(stderr,"Cxg̎ނ肦Ȃ('A`)%d readtrack\n",eventtype);exit(1);
			}

			//ŃCxgf[^ǂ
			eventdata = malloc(eventlen);
			if(eventdata == NULL){fprintf(stderr,"mallocł('A`) readtrack\n");exit(1);}
			fread(eventdata,1,eventlen,fp);	datacursor += eventlen;
			retrack->trackcursor[eventch]->event->data = eventdata;

			//xVeB0̃m[gI̓m[gItɕϊ
			if(eventtype == NON){	//eventdata == retrack->(ry)->data 狖(د
				if(eventdata[1] == 0){retrack->trackcursor[eventch]->event->type = NOFF;}
			}

		}
	//̃Cxgǂ
	//printf("%d\t%d\t%d\t%d\t%d\n",eventtime,eventtype,tracknum,eventlen,datacursor);

	}
}

//smfJ
midiseq *readsmf(char *filename){
	unsigned int rint;	//ǂݍݗp
	unsigned short rshort;	//ǂݍݗp

	int trackcount;	//gbN

	midiseq *midiseqs;	//midif[^ɓ˂ŕԂ

	FILE *fp;
	//oCi[hŃt@CJ
	if ((fp = fopen(filename, "rb")) == NULL){fprintf(stderr,"̓t@CJȂ('A`)\n");	exit(1);}

	//`NJ ŏȂ̂MThd0x000000066oCgȂƂ
	fread(&rint,4,1,fp);	//MThd
	convertEndian(&rint,4);
	if(rint != MThd){fprintf(stderr,"MThdŎn܂ĂȂ('A`) {.midt@C?%x\n",rint);exit(1);}

	fread(&rint,4,1,fp);	//0x00000006(f[^6oCg)
	convertEndian(&rint,4);
	if(rint != 6){fprintf(stderr,"MThd̃TCYႤ('A`)%d\n",rint);exit(1);}

	fread(&rshort,2,1,fp);	//tH[}bg(0,1)
	convertEndian(&rshort,2);
	if(rshort == 2){fprintf(stderr,"܂ȂAFormat2͑ΉĂȂ(LEցEM)\n");exit(1);}
	if(rshort != 1 && rshort != 0){fprintf(stderr,"Format0ł1łȂ('A`)%d\n",rshort);exit(1);}

	fread(&rshort,2,1,fp);	//gbN
	convertEndian(&rshort,2);
	trackcount = (int)rshort;

	//midiseq̏
	if(trackcount == 1){
		midiseqs = newmidiseq(16);	//16ch16gbN Ƃ
	}else{
		midiseqs = newmidiseq(trackcount);
	}
	
	fread(&rshort,2,1,fp);	//\
	convertEndian(&rshort,2);
	midiseqs->timebase = (int)rshort;
	if(midiseqs->timebase & 0x8000){fprintf(stderr,"\\܂̎ԕ('A`)%d\n̂܂ܑ邯ǂƑ󂷂(LEցEM)\n",midiseqs->timebase);}

	//egbNǂݏo

	if(trackcount == 1){
		readtrack(fp,midiseqs,-1);	//1gbNȂFormat1łFormat0ƓlchgbN Ƃ
	}else{
		int i;
		for(i=0;i<trackcount;i++){
			readtrack(fp,midiseqs,i);
		}
	}

	//t@CďI
	fclose(fp);
	return midiseqs;
}


//--------------------------------------
//	Cxg̈Ɏg邩֐
//--------------------------------------


//e|ύX̃Cxg𓊂ƃe|̐lԂ
//e|ȊÕCxg𓊂ꍇ-1Ԃ
int solvetempo(midievent *event){
	int a,i;

	if(event->metaeventtype != 0x51){return -1;}
	a = 0;
	for(i=0;i < event->len;i++){	//sPʂ̃e|ǂ
		a <<= 8;
		a |= event->data[i];
	}

	a = 60000000 / a ;	//_ȉ؂̂ĂȂ̂łł

	if(a<1){return 1;}	//e|0Ԃ̂͂낢_
	return a;
}


void smfmeasure(midiseq *midiseqs ,const int smftime, int *measure, int *beat, int *tick){
	//SMF̃}X^[gbNɏ:q:tick vZĕԂ

	int bm = 4;	// bm/bdq
	int bd = 4;
	int currenttime = 0;	//܂ŃJEgSMF
	
	*measure = 0;	// 1𑫂
	*beat = 0;	// 1𑫂
	*tick = 0;
	
	midichlist *localcursor;	//}X^[gbNǂݍݗp
	
	//}X^[gbN𔏎qύXǂ
	for(localcursor = midiseqs->master->next; localcursor != NULL; localcursor = localcursor->next){
		if(localcursor->event->time > smftime){break;}	//smftimeȂ疳ďI
		
		if(localcursor->event->metaeventtype == 0x58){
			if(localcursor->event->len < 2){localcursor = localcursor->next; continue;}	//炩ɃoCgȂꍇ͖
			//qύX܂ł̏ߐvZ
			*measure += (localcursor->event->time - currenttime) / (midiseqs->timebase * 4 * bm / bd);
			//߂̓rɔqύXꍇ͋IɎ̏߂Ƃ
			if((localcursor->event->time - currenttime) % (midiseqs->timebase * 4 * bm / bd)){
				*measure += 1;
			}
			//qǂݍ
			currenttime = localcursor->event->time;
			bm = localcursor->event->data[0];	//q͂̂܂
			bd = 1 << localcursor->event->data[1];	//vZ 2^x ŕ\
		}
	}

	//smtime܂ł̏ߐvZ 1𑫂
	*measure += 1 + (smftime - currenttime) / (midiseqs->timebase * 4 * bm / bd);
	//vZ 1𑫂
	*beat = 1 + (smftime - currenttime) % (midiseqs->timebase * 4 * bm / bd) / (midiseqs->timebase * 4 / bd);
	//tickvZ
	*tick = (smftime - currenttime) % (midiseqs->timebase * 4 / bd);
}


//**************************************
//	MML
//**************************************

int nextsplitmeasure(midiseq *midiseqs ,const int smftime, const int splitunit, const int splitoffset){
	//SMF̃}X^[gbNaddmeasureߑsmfԂ
	//Ȃ̏IɂȂseqlengthԂ

	//splitunit1̏ꍇ͕Ȃ
	if(splitunit <= 0){return midiseqs->seqlength;}

	//܂ȂƎvǂłɋȂIĂseqlengthԂ
	if(midiseqs->seqlength <= smftime){return midiseqs->seqlength;}

	int i;
	int bm = 4;	// bm/bdq
	int bd = 4;
	int measure = 0;	//߃JEgp
	int addmeasure;
	int minioffset;	//splitunitɂsplitoffset
	int currenttime = 0;	//܂ŃJEgSMF

	midichlist *localcursor;	//}X^[gbNǂݍݗp
	localcursor = midiseqs->master->next;

	//smftime܂ňCɐi
	//}X^[gbN𔏎qύXǂ
	for(localcursor = midiseqs->master->next; localcursor != NULL; localcursor = localcursor->next){
		if(localcursor->event->time > smftime){break;}	//_Ă鎞Ȃ疳ďI
		
		if(localcursor->event->metaeventtype == 0x58){
			if(localcursor->event->len < 2){localcursor = localcursor->next; continue;}	//炩ɃoCgȂꍇ͖
			//qύX܂ł̏ߐvZ
			measure += (localcursor->event->time - currenttime) / (midiseqs->timebase * 4 * bm / bd);
			//߂̓rɔqύXꍇ͋IɎ̏߂Ƃ
			if((localcursor->event->time - currenttime) % (midiseqs->timebase * 4 * bm / bd)){
				measure += 1;
			}
			//qǂݍ
			currenttime = localcursor->event->time;
			bm = localcursor->event->data[0];	//q͂̂܂
			bd = 1 << localcursor->event->data[1];	//vZ 2^x ŕ\
		}
	}


	//smftimȅߐ̌vZ
	measure += (smftime - currenttime) / (midiseqs->timebase * 4 * bm / bd);
	//currenttimeΉʒu܂Ői߂
	currenttime += (smftime - currenttime) / (midiseqs->timebase * 4 * bm / bd) * (midiseqs->timebase * 4 * bm / bd);

	//iސ̏ߐ̌
	addmeasure = measure;
	minioffset = splitoffset % splitunit;
	if(measure < splitoffset){
		addmeasure = splitoffset;	//ŏ̕ʒuɓ͂ĂȂ̂ł܂
	}else{	//̕ʒuvZ
		addmeasure = measure / splitunit * splitunit + splitunit + minioffset;
	}

//	printf("%d\t%d\t%d\t%d\t%d\t%d\n",currenttime,smftime,measure,splitunit,minioffset,addmeasure);

	//1߂Tdɂi
	for(i=measure;i<addmeasure;i++){
		currenttime += (midiseqs->timebase * 4 * bm / bd);
		if(currenttime > midiseqs->seqlength){return midiseqs->seqlength;}	//Ȃ̏IɓB̂łԂ
		//}X^[gbN𔏎qύXǂ
		for(; localcursor != NULL; localcursor = localcursor->next){
			if(localcursor->event->time > currenttime){break;}	//̏߂Ȃ疳ďI

			if(localcursor->event->metaeventtype == 0x58){
				if(localcursor->event->len < 2){continue;}	//炩ɃoCgȂꍇ͖
				//qǂݍ
				currenttime = localcursor->event->time;
				bm = localcursor->event->data[0];	//q͂̂܂
				bd = 1 << localcursor->event->data[1];	//vZ 2^x ŕ\
			}
		}
	}
//	printf("%d\t%d\t%d\t%d\t%d\n",currenttime,smftime,measure,splitunit,minioffset);
	return currenttime;
}


int nextsplit(midiseq *midiseqs, const int currenttime, const int splitunit, const int splitoffset){
	//}X^[gbNǂŎ̕ʒuԂ
	int a;	//vZp

	//splitunitsplitoffsetvZʒu
	a = nextsplitmeasure(midiseqs ,currenttime, splitunit, splitoffset);

	if(midiseqs->mastercursor != NULL){	//}X^[gbN̎̃Cxg
		if(midiseqs->mastercursor->event->time < a){a = midiseqs->mastercursor->event->time;}
	}
	return a;
}


int nextsplitnote(midiseq *midiseqs, const int tempo, int limit){
	//limit̎܂ł̃}X^[gbNǂŁÃm[g̕ʒuԂ
	//Ȃ킿̃e|ύXʒu()
	//nextsplitƃZbg

	//tempoTrueɂƑɎ̃e|Ԃ e|ύXȂꍇ-1

	midichlist *localmastercursor;	//QƗp

	if(midiseqs->mastercursor != NULL){	
		localmastercursor = midiseqs->mastercursor;

		//}X^[gbNe|ύXǂݍ
		for(localmastercursor = midiseqs->mastercursor; localmastercursor != NULL; localmastercursor = localmastercursor->next){
			if(localmastercursor->event->time > limit){break;}	//limit߂I
			if(localmastercursor->event->metaeventtype == 0x51){	//e|ύXo
				if(tempo){
					//e|Ԃ̂Ńe|vZ
					return solvetempo(localmastercursor->event);
				}
				return localmastercursor->event->time;
			}
		}
	}
	//e|ύXȂꍇ
	if(tempo){return -1;}
	return midiseqs->seqlength;
}

void writemidimetaevent(FILE *fp, midievent *event){
	//midi^Cxg1o͂
	//^CxgȊO𓊂ƉȂ
	//gbNỎs͏o͂Ȃ

	enum datatype{TXT,NCT,NUM,HEX,SPC} datatype;	//}X^[gbÑf[^̎
	int i;
	int a;	//vZp

	if(event->metaeventtype < 0){return;}	//^CxgȂ

	switch(event->metaeventtype){
		case 0x00:	//V[PXԍ
			fprintf(fp,"/*Sequence ");
			datatype = NUM;
			break;
		case 0x01:	//eLXg
			fprintf(fp,"/*Text ");
			datatype = TXT;
			break;
		case 0x02:	//쌠\
			fprintf(fp,"#MAKER ");
			datatype = TXT;
			break;
		case 0x03:	//gbNA^Cg
			fprintf(fp,"/*TrackTitle ");
			datatype = TXT;
			break;
		case 0x04:	//y햼
			fprintf(fp,"/*Instrument ");
			datatype = TXT;
			break;
		case 0x05:	//̎
			fprintf(fp,"/*Lyric ");
			datatype = TXT;
			break;
		case 0x06:	//}[J[
			fprintf(fp,"/*Marker ");
			datatype = TXT;
			break;
		case 0x07:	//L[|Cg
			fprintf(fp,"/*CuePoint ");
			datatype = TXT;
			break;
		case 0x08:	//vO(F)
			fprintf(fp,"/*Program ");
			datatype = TXT;
			break;
		case 0x09:	//foCX()
			fprintf(fp,"/*Device ");
			datatype = TXT;
			break;
		case 0x0a:	//̑̃eLXg
		case 0x0b:
		case 0x0c:
		case 0x0d:
		case 0x0e:
		case 0x0f:
			fprintf(fp,"/*MiscText ");
			datatype = TXT;
			break;
		case 0x10:	//MIDI`lvtBbNX
			fprintf(fp,"/*MIDIchPrefix ");
			datatype = NUM;
			break;
		case 0x21:	//|[gw
			fprintf(fp,"/*Port ");
			datatype = NUM;
			break;
		case 0x2f:	//gbNI
			fprintf(fp,"/*TrackEnd");
			datatype = HEX;
			break;
		case 0x51:	//e|
			datatype = SPC;
			break;
		case 0x54:	//SMPTE^CR[h
			fprintf(fp,"/*SMPTE ");
			datatype = HEX;
			break;
		case 0x58:	//q
			fprintf(fp,"/*Time ");
			datatype = SPC;
			break;
		case 0x59:	//
			fprintf(fp,"/*Key ");
			datatype = SPC;
			break;
		case 0x7f:	//V[PTCxg
			fprintf(fp,"/*SeqencerExculsive ");
			datatype = HEX;
			break;
		default:	//ȃ^Cxgm邩('A`)
			fprintf(fp,"/*UnknownMeta %02X ",event->metaeventtype);
			datatype = HEX;
	}

	//datatype̒ʂɃf[^o
	switch(datatype){
		case TXT:	//eLXg
			for(i=0;i<event->len;i++){fprintf(fp,"%c",event->data[i]);}
			fprintf(fp,"*/");
			break;
		case NCT:	//RgɂȂeLXg
			for(i=0;i<event->len;i++){fprintf(fp,"%c",event->data[i]);}
			break;
		case NUM:	//10i
			a = 0;
			for(i=0;i<event->len;i++){
				a <<= 8;
				a |= event->data[i];
			}
			fprintf(fp,"%d*/",a);
			break;
		case HEX:	//16i 0oCg̃f[^ŏ
			for(i=0;i<event->len;i++){fprintf(fp,"%02X",event->data[i]);}
			fprintf(fp,"*/");
			break;
		case SPC:	//Cxgޕ
			switch(event->metaeventtype){
				case 0x51:	//e|
					//SẴgbNԍo

					//e|vZ
					fprintf(fp,"t%d",solvetempo(event));
					break;

				case 0x58:	//q
					if(event->len < 2){break;}	//炩ɃoCgȂꍇ͖
					a = 1 << event->data[1];	//vZ 2^x ŕ\
					fprintf(fp,"%d/%d*/",event->data[0],a);
					break;
				case 0x59:	//
					if(event->len < 2){break;}	//炩ɃoCgȂꍇ͖
					switch(event->data[0]){
						case 249:	//7 ȉl
							if(event->data[1]){fprintf(fp,"Ab Minor");}else{fprintf(fp,"Cb Major");}break;
						case 250:
							if(event->data[1]){fprintf(fp,"Eb Minor");}else{fprintf(fp,"Gb Major");}break;
						case 251:
							if(event->data[1]){fprintf(fp,"Bb Minor");}else{fprintf(fp,"Db Major");}break;
						case 252:
							if(event->data[1]){fprintf(fp,"F Minor");}else{fprintf(fp,"Ab Major");}break;
						case 253:
							if(event->data[1]){fprintf(fp,"C Minor");}else{fprintf(fp,"Eb Major");}break;
						case 254:
							if(event->data[1]){fprintf(fp,"G Minor");}else{fprintf(fp,"Bb Major");}break;
						case 255:
							if(event->data[1]){fprintf(fp,"D Minor");}else{fprintf(fp,"F Major");}break;
						case 0:	//Ȃ
							if(event->data[1]){fprintf(fp,"A Minor");}else{fprintf(fp,"C Major");}break;
						case 1:	//#1 ȉl
							if(event->data[1]){fprintf(fp,"E Minor");}else{fprintf(fp,"G Major");}break;
						case 2:
							if(event->data[1]){fprintf(fp,"B Minor");}else{fprintf(fp,"D Major");}break;
						case 3:
							if(event->data[1]){fprintf(fp,"F# Minor");}else{fprintf(fp,"A Major");}break;
						case 4:
							if(event->data[1]){fprintf(fp,"C# Minor");}else{fprintf(fp,"E Major");}break;
						case 5:
							if(event->data[1]){fprintf(fp,"G# Minor");}else{fprintf(fp,"B Major");}break;
						case 6:
							if(event->data[1]){fprintf(fp,"D# Minor");}else{fprintf(fp,"F# Major");}break;
						case 7:
							if(event->data[1]){fprintf(fp,"A# Minor");}else{fprintf(fp,"C# Major");}break;
						default:	//
							fprintf(fp,"Unknown %02X%02X",event->data[0],event->data[1]);
					}
					fprintf(fp,"*/");
					break;
				default:	//NULL̂ƂƂŉȂ
					;
			}
			break;
		default:	//
			fprintf(stderr,"datatypeȂ('A`) %d\n",datatype);exit(1);
	}
}


void writemmlnotenum(FILE *fp, char midinote){
	//midim[gԍmml̃m[gvZďo
	fprintf(fp,"o%d",midinote / 12 - 1);	//IN^[u
	switch(midinote % 12){
		case 0:
			fprintf(fp,"c");break;
		case 1:
			fprintf(fp,"c+");break;
		case 2:
			fprintf(fp,"d");break;
		case 3:
			fprintf(fp,"d+");break;
		case 4:
			fprintf(fp,"e");break;
		case 5:
			fprintf(fp,"f");break;
		case 6:
			fprintf(fp,"f+");break;
		case 7:
			fprintf(fp,"g");break;
		case 8:
			fprintf(fp,"g+");break;
		case 9:
			fprintf(fp,"a");break;
		case 10:
			fprintf(fp,"a+");break;
		case 11:
			fprintf(fp,"b");break;
		default:	//Ȃ
			;
	}
}


void writemidievent(FILE *fp, midievent *event, const int tracknum, int *newevent){
	//midiCxg1o͂
	//gbNỎs͏o͂Ȃ
	//m[g͏o͂Ȃ̂ő̃Cxg
	//neweventȂ琳̒lɂ NULLȂ疳(}X^[gbNp)
	//tracknum͕Kvȏꍇ̂ݏo͂
	if(newevent != NULL){
		if(*newevent){	//Cxg܂o͂ĂȂ
			fprintf(fp,"Tr%02d ", tracknum);	//gbNԍo
			*newevent = 0;
		}else{
			fprintf(fp," ");	//OɃCxĝŃXy[Xo
		}
	}

	int i;
	//Cxg1o͂
	if(event->metaeventtype >= 0){	//^Cxg
		writemidimetaevent(fp,event);
	}else{
		//ʂmidiCxg
		switch(event->type){	//{NOFF,NON,PKP,CC,PC,AT,PB,X}
			case PKP:
				fprintf(fp,"/*PKP ");
				writemmlnotenum(fp,event->data[0]);	//m[g
				fprintf(fp," %d*/",event->data[1]);	//xVeB
				break;
			case CC:
				fprintf(fp,"/*CC%d %d*/",event->data[0],event->data[1]);
				break;
			case PC:
				fprintf(fp,"/*PC%d*/",event->data[0]);
				break;
			case AT:
				fprintf(fp,"/*AT%d*/",event->data[0]);
				break;
			case PB:
				//sb`xh̓ǂݍ݂ƌvZ
				i = ((int)event->data[1] << 7 | (int)event->data[0]) - 8192;
				fprintf(fp,"/*PB%d*/",i);
				break;
			case X:
				fprintf(fp, "/*SYSEX ");
				for(i=0;i < event->len;i++){fprintf(fp,"%02X",event->data[i]);}
				fprintf(fp,"*/");
				break;
			default:	//m[g͖
				;
		}
	}
}


void writemmltime(FILE *fp,const int smftime, const int smftimebase){
	//MMLp̃m[g\LvZďo
	const int minmmlnote = 128;	//MMLm[g̍ŏP(n)
	int minsmftime;	//MMLŕ\\ȍŏSMFm[g
	int smftimerest;	//cSMFm[g

	smftimerest = smftime;
	minsmftime = smftimebase / (minmmlnote / 4);
	if(minsmftime == 0){minsmftime = 1;}

	int noteunit = 1;	//no͂
	int resumenote = 0;	//^CKvǂ

	//m[gvZ
	for(smftimerest = smftime;smftimerest >= minsmftime;smftimerest -= smftimebase*4/noteunit){
		while(smftimerest < smftimebase*4/noteunit && minsmftime <= smftimebase*4/noteunit){noteunit *= 2;}
		if(minsmftime <= smftimebase*4/noteunit){	//Ńm[go
			if(resumenote){	//2ڂ^Ct
				fprintf(fp,"^%d",noteunit);
			}else{
				fprintf(fp,"%d",noteunit);
				resumenote = -1;
			}
		}else{
			//m[ĝŌx m[g0m[gLڂȂ hminmmlnote
			//vɉɔɂ
			fprintf(stderr,"m[gMMLŕ\\łȂ̂ł(LEցEM) /tIvVĂ\n");
			if(resumenote){	//2ڂ^Ct
				fprintf(fp,"^%d",minmmlnote);
			}else{
				fprintf(fp,"%d",minmmlnote);
			}
		}
	}
}

void writemmlnote(FILE *fp, const char midinote, const int smftime, const int mmltimebase, const int tracknum, int *newevent){
	//MMLp̃m[gꎮo ̃Xy[X
	//midinoteɕ̒lƋxo
	//neweventTrueȂgbNԍo͂Falseɂ
	
	if(smftime < 1){return;}	//smftime1ł͉o͂Ȃ
	if(*newevent){fprintf(fp,"Tr%02d", tracknum); *newevent = 0;}	//KvȂgbNԍo
	if(midinote < 0){
		fprintf(fp," r");
	}else{
		fprintf(fp," ");
		writemmlnotenum(fp, midinote);
	}
	writemmltime(fp, smftime, mmltimebase);
}


//midiseqs->mastercursor wCxg
//limitŎw肳ꂽԂ܂ł̃}X^[gbNo
//tracknumŃgbNԍwA̒lőSgbNꊇw
void writemaster(FILE *fp, midiseq *midiseqs, const int limit, const int tracknum){
	//}X^[gbNlimit܂œǂ
	for(; midiseqs->mastercursor != NULL; midiseqs->mastercursor = midiseqs->mastercursor->next){
		if(midiseqs->mastercursor->event->time > limit){break;}

		//e|ύX̑OgbNԍo
		if(midiseqs->mastercursor->event->metaeventtype == 0x51){
			int trackcount = 0;
			if(tracknum < 0){	//SgbN
				int i;
				for(i=0;i < midiseqs->trackcount;i++){
					if(midiseqs->trackcursor[i] != NULL){	//IgbN͏o͂Ȃ
						fprintf(fp,"Tr%02d",i);
						trackcount++;
					}
				}
			}else{	//w肳ꂽgbN
				if(midiseqs->trackcursor[tracknum] != NULL){	//IgbN͏o͂Ȃ
					fprintf(fp,"Tr%02d",tracknum);
					trackcount++;
				}
			}
			//e|ύXgbN΃e|o
			if(trackcount){
				fprintf(fp," ");
				writemidievent(fp,midiseqs->mastercursor->event,0,NULL);
			}
			
		}else{	//e|ύXȊO
			//Cxg1o
			writemidievent(fp,midiseqs->mastercursor->event,0,NULL);
		}

		//so͂Ă玟̃Cxg
		fprintf(fp,"\n");
	}
}

//writetrackp̃m[gۑ\
struct mmlnotecursor{
	midievent **lastnote;	//Ōɏm[gON/OFFCxg
	int *start;	//̃m[g/x ̊Jnʒu m[gl
};
typedef struct mmlnotecursor mmlnotecursor;

mmlnotecursor *newmmlnotecursor(const int trackcount){
	mmlnotecursor *ret;
	int i;

	ret = malloc(sizeof(mmlnotecursor));
	if(ret == NULL){fprintf(stderr,"mallocł('A`) newmmlnotecursor\n");exit(1);}
	ret->lastnote = malloc(trackcount * sizeof(midievent));
	if(ret == NULL){fprintf(stderr,"mallocł('A`) newmmlnotecursor\n");exit(1);}
	ret->start = malloc(trackcount * sizeof(int));
	if(ret == NULL){fprintf(stderr,"mallocł('A`) newmmlnotecursor\n");exit(1);}

	//evf̏
	for(i=0;i<trackcount;i++){
		ret->lastnote[i] = NULL;
		ret->start[i] = 0;
	}
	return ret;
}

void writetrack(FILE *fp, midiseq *midiseqs, mmlnotecursor *notecursors, const int mmltimebase, const int limit, const int tracknum, const int splitnote){
	//midiseqs->trackcursor[] wCxg
	//limitŎw肳ꂽԂ܂ł̊egbNo
	//splitnotetrueɂƏI[Ńm[g𕪊
	//mmltimebaseŉ̒SʕύX
		
	int newevent = -1;	//gbNԍ̏o͂Kvǂ
	//Cxglimit܂œǂ
	for(; midiseqs->trackcursor[tracknum] != NULL; midiseqs->trackcursor[tracknum] = midiseqs->trackcursor[tracknum]->next){
		if(midiseqs->trackcursor[tracknum]->event->time > limit){break;}
		switch(midiseqs->trackcursor[tracknum]->event->type){	//{NOFF,NON,PKP,CC,PC,AT,PB,X}
			case NOFF:
				if(notecursors->lastnote[tracknum] != NULL){
					if(notecursors->lastnote[tracknum]->type == NON){
						//炵Ă鉹ɑΉm[gItǂ Ⴄ̃m[głΖ(㒅D)
						//ƒ0̃m[gƌȂꍇ͂̃m[gIt𖳎(Ał̃m[g΍)
						//_um[g͓rŐ؂邯ǎdȂ
						if(midiseqs->trackcursor[tracknum]->event->data[0] == notecursors->lastnote[tracknum]->data[0]
							&& midiseqs->trackcursor[tracknum]->event->time > notecursors->lastnote[tracknum]->time){
							//m[ǵA邢͕ꂽm[g̎co
							writemmlnote(fp,notecursors->lastnote[tracknum]->data[0], midiseqs->trackcursor[tracknum]->event->time - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);
						}else{
							//̃m[gIt𖳎Ď̃Cxg start͍XVȂ
							continue;
						}
					}else if(notecursors->lastnote[tracknum]->type == NOFF){
						//m[gdȂĂƃm[gIt̘Âŋxč킹
						writemmlnote(fp, -1, midiseqs->trackcursor[tracknum]->event->time - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);	//KvȂxo
					}
				}else{	//Ȃm[gIt͉ǈꉞ
					writemmlnote(fp, -1, midiseqs->trackcursor[tracknum]->event->time - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);	//KvȂxo
				}
				//lastnoteXV
				notecursors->lastnote[tracknum] = midiseqs->trackcursor[tracknum]->event;
				break;
			case NON:
				if(notecursors->lastnote[tracknum] != NULL){
					if(notecursors->lastnote[tracknum]->type == NON){//m[gdȂĂ̂Ō㒅Dɂ
						//m[ǵA邢͕ꂽm[g̎co
						writemmlnote(fp, notecursors->lastnote[tracknum]->data[0], midiseqs->trackcursor[tracknum]->event->time - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);
					}else if(notecursors->lastnote[tracknum]->type == NOFF){	//ʂ̃m[gON
						writemmlnote(fp, -1, midiseqs->trackcursor[tracknum]->event->time - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);	//KvȂxo
					}
				}else{	//ŏ̃m[g
					writemmlnote(fp, -1, midiseqs->trackcursor[tracknum]->event->time - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);	//KvȂxo
				}
				//lastnoteXV
				notecursors->lastnote[tracknum] = midiseqs->trackcursor[tracknum]->event;
				break;
			default:	//̑̃Cxg x ͌ɂ
				if(notecursors->lastnote[tracknum] != NULL){
					if(notecursors->lastnote[tracknum]->type == NON){
						//Ă遨startXVȂ Cxg͏o͂
						writemidievent(fp,midiseqs->trackcursor[tracknum]->event, tracknum, &newevent);
						continue;
					}
				}
				//݉ĂȂA܂͍܂ňxĂȂꍇ
				writemmlnote(fp, -1, midiseqs->trackcursor[tracknum]->event->time - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);	//KvȂxo
				//Cxg1o ̂ƂSRg
				writemidievent(fp,midiseqs->trackcursor[tracknum]->event, tracknum, &newevent);
		}
		//startXV
		notecursors->start[tracknum] = midiseqs->trackcursor[tracknum]->event->time;
	}

	//m[gs
	if(midiseqs->trackcursor[tracknum] != NULL){	//gbNIĂȂƂO
		if(notecursors->lastnote[tracknum] == NULL){	//܂ĂȂ̂ŋxo
			writemmlnote(fp, -1, limit - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);
			notecursors->start[tracknum] = limit;
		}else{
			if(notecursors->lastnote[tracknum]->type == NOFF){	//ĂȂԂȂxo
				writemmlnote(fp, -1, limit - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);
				notecursors->start[tracknum] = limit;
			}else if(notecursors->lastnote[tracknum]->type == NON){	//Ă̂splitnoteɉĕ
				if(splitnote){
					//limiẗʒuŕ
					writemmlnote(fp, notecursors->lastnote[tracknum]->data[0], limit - notecursors->start[tracknum], mmltimebase, tracknum, &newevent);
					notecursors->start[tracknum] = limit;
				}else{
					//Ȃ ɎstartOɂ炷
					notecursors->start[tracknum] = notecursors->lastnote[tracknum]->time;
				}
			}
		}
	}
	//so͂ďI
	if(!newevent){fprintf(fp,"\n");}
}

void writeallseq(FILE *fp, midiseq *midiseqs, const int mmltimebase, const int splitunit, const int splitoffset){
	//}X^[gbN̕KvȃCxgƂɑSgbN𕪊Ȃo
	//e|ύX͉𕪊 ȊȎ͉O

	int i, j;
	//gbN̓o
	for(i=0;i < midiseqs->trackcount;i++){midiseqs->trackcursor[i] = midiseqs->track[i]->next;}
	midiseqs->mastercursor = midiseqs->master->next;

	//ߐo͗p
	int measure;
	int beat;
	int tick;

	//notecursoȑ
	mmlnotecursor *notecursors;
	notecursors = newmmlnotecursor(midiseqs->trackcount);

	//splitunitƂɕA}X^[gbNƂɕB
	int timecursor = 0;	//̎Ԉʒu
	while(timecursor < midiseqs->seqlength){
		//̕ʒuT
		timecursor = nextsplit(midiseqs,timecursor,splitunit,splitoffset);
		if(timecursor == nextsplitnote(midiseqs,0,timecursor)){	//e|ύX==m[gꍇ
			for(j=0;j < midiseqs->trackcount;j++){
				writetrack(fp, midiseqs, notecursors, mmltimebase, timecursor, j, -1);
			}
		}else{	//e|ύXȂ
			for(j=0;j < midiseqs->trackcount;j++){
				writetrack(fp, midiseqs, notecursors, mmltimebase, timecursor, j, 0);
			}
		}
		writemaster(fp,midiseqs,timecursor, -1);	//}X^[gbNo

		//ߐo
		smfmeasure(midiseqs ,timecursor, &measure, &beat, &tick);
		fprintf(fp,"\n/*%d:%02d:%03d*/\n",measure,beat,tick);
	}
}

void writetrackseq(FILE *fp, midiseq *midiseqs, const int mmltimebase, const int splitunit, const int splitoffset){
	//}X^[gbN̕KvȃCxgƂɊegbN𕪊Ȃo
	//1gbNƂɕďo͂
	//e|ύX͉𕪊 ȊȎ͉O

	int i;

	//ߐo͗p
	int measure;
	int beat;
	int tick;

	//notecursoȑ
	mmlnotecursor *notecursors;
	notecursors = newmmlnotecursor(midiseqs->trackcount);

	//splitunitƂɕA}X^[gbNƂɕB
	int timecursor;	//̎Ԉʒu
	int contenttrack;	//NULLȂgbN

	//1gbNo
	for(i=0;i < midiseqs->trackcount;i++){
		//gbN̓o
		midiseqs->trackcursor[i] = midiseqs->track[i]->next;
		midiseqs->mastercursor = midiseqs->master->next;
		timecursor = 0;
		contenttrack = 0;
		
		while(timecursor < midiseqs->seqlength && midiseqs->trackcursor[i] != NULL){
			contenttrack = -1;
			//̕ʒuT
			timecursor = nextsplit(midiseqs,timecursor,splitunit,splitoffset);
			if(timecursor == nextsplitnote(midiseqs,0,timecursor)){	//e|ύX==m[gꍇ
				writetrack(fp, midiseqs, notecursors, mmltimebase, timecursor, i, -1);
			}else{	//e|ύXȂ
				writetrack(fp, midiseqs, notecursors, mmltimebase, timecursor, i, 0);
			}
			writemaster(fp,midiseqs,timecursor, i);	//}X^[gbNo

			//ߐo
			smfmeasure(midiseqs ,timecursor, &measure, &beat, &tick);
			fprintf(fp,"\n/*%d:%02d:%03d*/\n",measure,beat,tick);
		}
		if(contenttrack){fprintf(fp, "\n\n");}	//so͂Ă玟̃gbN
	}
}

void makemml(char *filename, midiseq *midiseqs, const int mmltimebase, const int splitunit, const int splitoffset, const int separatetracks){

	FILE *fp;
	//eLXg[hŃt@CJ
	if ((fp = fopen(filename, "w")) == NULL){fprintf(stderr,"o̓t@CJȂ('A`)\n");	exit(1);}

	if(separatetracks){
		writetrackseq(fp, midiseqs, mmltimebase, splitunit, splitoffset);
	}else{
		writeallseq(fp, midiseqs, mmltimebase, splitunit, splitoffset);
	}
	//t@CďI
	fclose(fp);
}

//--------------------------------------
//	fobOp
//--------------------------------------
void showmidiseq(midiseq *midiseqs){
	//gbN̓o
	int i;
	for(i=0;i < midiseqs->trackcount;i++){midiseqs->trackcursor[i] = midiseqs->track[i]->next;}

	for(i=0;i < midiseqs->trackcount;i++){
		printf("Tr%02d\n",i);
		for(; midiseqs->trackcursor[i] != NULL; midiseqs->trackcursor[i] = midiseqs->trackcursor[i]->next){
			printf("%d\t%d\n",midiseqs->trackcursor[i]->event->time,midiseqs->trackcursor[i]->event->type);
		}
	}
}


//**************************************
//	Main
///**************************************
int main(int argc, char *argv[]){
	if(argc < 2){fprintf(stderr,".midt@Cw肵(LEցEM)");exit(1);}
	
	midiseq *midiseqs; //midif[^
	
	char *inputfilename = NULL;	//t@C Ȃargv[1]
	int splitunit = 1;	//P
	int splitoffset = 0;
	int mmltimebase;
	int tm = 1;
	int td = 1;	//\ύX
	int splittracks = 0;	//gbNʂɏo͂
	
	//R}hCǂ
	int i;
	for(i=1;i<argc;i++){
		if(argv[i][0] == '/'){	//XCb`
			if(strlen(argv[i]) < 2){fprintf(stderr,"ȃXCb`? t@C͍ŏɓāAXy[X܂܂ꍇ̓_uNIe[Vŋł(LEցEM) %s",argv[i]);exit(1);}
			switch(argv[i][1]){
				case 's':	//splitunit ߒP
				case 'S':
					if(strlen(argv[i]) < 3){fprintf(stderr,"ȃXCb`? t@C͍ŏɓāAXy[X܂܂ꍇ̓_uNIe[Vŋł(LEցEM) %s",argv[i]);exit(1);}
					splitunit = atoi(&argv[i][2]);
					break;
				case 'o':	//splitoffset ߒP
				case 'O':
					if(strlen(argv[i]) < 3){fprintf(stderr,"ȃXCb`? t@C͍ŏɓāAXy[X܂܂ꍇ̓_uNIe[Vŋł(LEցEM) %s",argv[i]);exit(1);}
					splitoffset = atoi(&argv[i][2]);
					if(splitoffset < 0){splitoffset = 0;}
					break;
				case 't':	//\ύX
				case 'T':
					if(strlen(argv[i]) < 3){fprintf(stderr,"ȃXCb`? t@C͍ŏɓāAXy[X܂܂ꍇ̓_uNIe[Vŋł(LEցEM) %s",argv[i]);exit(1);}
					tm = atoi(strtok(&argv[i][2],"/"));	//q
					char *tdc;
					tdc = strtok(NULL,"/");	//ꂪ邩ǂmF
					if(tdc != NULL){td = atoi(tdc);}	//
					break;
				case 'p':	//splittracks IvV̗L̂
				case 'P':
					splittracks = -1;
					break;
				default:	//`
					fprintf(stderr,"ȃXCb`? t@C͍ŏɓāAXy[X܂܂ꍇ̓_uNIe[Vŋł(LEցEM) %s",argv[i]);exit(1);
			}
		}else{	//t@Ĉ͂
			if(inputfilename == NULL){
				inputfilename = argv[i];
			}else{
				fprintf(stderr,"ȃXCb`? t@C͍ŏɓāAXy[X܂܂ꍇ̓_uNIe[Vŋł(LEցEM) %s",argv[i]);exit(1);
			}
		}
	}

	//.midt@Cǂ
	midiseqs = readsmf(inputfilename);

	//\ύX̐ݒ td/tm{(tȂ̂Œ) ܂艹ׂtm/td{
	mmltimebase = midiseqs->timebase * td / tm;
	if(mmltimebase <= 0){fprintf(stderr,"A/t ͂(LEցEM)");exit(1);}

	//.mml t@C ***.mid.mmlɂ(蔲)
	char *outfilename;
	outfilename = malloc(strlen(inputfilename) + 5 * sizeof(char));
	strcpy(outfilename, inputfilename);
	strcat(outfilename, ".mml");
	makemml(outfilename, midiseqs, mmltimebase, splitunit,splitoffset,splittracks);

	return 0;
}
